//添加按钮提示气泡
function addPrompt(hidden) {
    var element = document.getElementById("showAuthPrompt");
    if (element) {
        if (hidden) {
            console.log("hidden");
            element.style.visibility = 'hidden';
        } else {
            element.style.visibility = '';
        }
        return;
    }

    if (hidden) {
        return;
    }

    if (screen.height < screen.width) {
        return;
    }

    var container = document.getElementById("security-dialog_QMDialog");
    if (!container) {
        return;
    }

    var img = document.createElement('img');
    img.src = 'https://nos.netease.com/avatars/5be6743c38bb658b1ac7f402d15d86d1.png';
    img.style.position = 'fixed';
    var scaleRatio = parseFloat(container.style.transform.slice(6,-1));
    var windowHeight = parseFloat(container.style.height) * (scaleRatio + 1) / 2;
    img.style.top = (parseFloat(container.style.top) + windowHeight).toString() + 'px';
    img.style.left = (parseFloat(container.style.left) - parseFloat(container.style.width) * (scaleRatio - 1) / 2).toString() + 'px';
    img.style.width = 222 * scaleRatio + 'px';
    img.style.height = 95 * scaleRatio + 'px';
    img.style.zIndex = 10000;
    img.id = 'showAuthPrompt';

    document.body.appendChild(img);
}

function addPrompt2(hidden) {
    var element = document.getElementById("showAuthPrompt2");

    if (element) {
        if (hidden) {
            console.log("hidden");
            element.style.visibility = 'hidden';
        } else {
            element.style.visibility = '';
        }
        return;
    }

    if (hidden) {
        return;
    }

    if (screen.height < screen.width) {
        return;
    }

    var container = document.getElementById("security-dialog_QMDialog");
    if (!container) {
        return;
    }

    var img = document.createElement('img');
    img.src = 'https://nos.netease.com/avatars/5b5c5e121d4b5498d47d5d2f06683e2c.png';
    img.style.position = 'fixed';
    var scaleRatio = parseFloat(container.style.transform.slice(6,-1));
    var windowHeight = parseFloat(container.style.height) * (scaleRatio + 1) / 2;
    img.style.top = (parseFloat(container.style.top) + windowHeight).toString() + 'px';
    img.style.right = (parseFloat(container.style.right) - parseFloat(container.style.width) * (scaleRatio - 1) / 2).toString() + 'px';
    img.style.width = 168 * scaleRatio + 'px';
    img.style.height = 76 * scaleRatio + 'px';
    img.style.zIndex = 10000;

    img.id = 'showAuthPrompt2';

    document.body.appendChild(img);
}

function getScale(securityDialog) {
    var clientWidth = parseInt(document.body.style.width);
    var clientHeight = parseInt(document.body.style.height);
    var windowWidth = parseInt(securityDialog.style.width);
    var windowHeight = parseInt(securityDialog.style.height);

    if (clientHeight > clientWidth) {
        // 竖屏
        return (clientWidth - 20 * 2) / windowWidth;
    } else {
        // 横屏
        return 0.6;
    }
}

// 放大并居中窗口
function centerPopWindow(windowName) {
    var securityDialog = document.getElementById(windowName);
    if (!securityDialog)
        return false;

    if (windowName == 'security-dialog_QMDialog') {
        document.getElementById("security-dialog_QMDialog__closebtn_").addEventListener("click", function() {
            location.reload();
        });
    } else if (windowName == 'security-dialogOpen_QMDialog') {
        // 实测该窗口没有height，这里手动帮他填上
        securityDialog.style.height = '200px';
    }

    var clientWidth = parseInt(document.body.style.width);
    var clientHeight = parseInt(document.body.style.height);
    var windowWidth = parseInt(securityDialog.style.width);
    var windowHeight = parseInt(securityDialog.style.height);

    // 缩放窗口
    var scale = 2;

    // 居中窗口
    securityDialog.style.left = "" + (clientWidth - windowWidth) / 2 + "px";
    securityDialog.style.right = securityDialog.style.left;
    if (clientWidth > clientHeight) {
        securityDialog.style.top = "-50px !important";
    } else {
        securityDialog.style.top = "" + (clientHeight - windowHeight) / 2 - 40 * scale  + "px";
        console.log(securityDialog.style.top);
    }
    securityDialog.style.transform = "scale(" + scale + ")";
    return true;
}

function onVerifyCodeFind() {
     window.setTimeout(function() {
        window.addBottomBtn("立即登陆", function() {
            onBottomBtnClick(4)();
            onVerifyCodeFind();
        });
     }, 500);
 }

function doPollAuthCodeWidow() {
    console.log("doPollAuthCodeWidow");
    // 解析auth code
    var QMDialog_body = document.getElementById('security-dialog_QMDialog__body_');
    if (!QMDialog_body) {
        return;
    }

    var code_span = QMDialog_body.getElementsByClassName('securePwd_cnt_left_num')[0];
    if (!code_span) {
        return;
    }

    // 隐藏气泡
    addPrompt(true);
    addPrompt2(true);

    console.log("doPollAuthCodeWidow");
    centerPopWindow('security-dialog_QMDialog');
    if (code_span.innerText.length > 0 && window.auth_code != code_span.innerText) {
        console.log("doPollAuthCodeWidow-3");
        // 结束轮询
        window.clearInterval("" + window.globle_tmid);
        window.globle_tmid = 0;
        window.auth_code = code_span.innerText;

        // 修改bottom按钮状态
        onVerifyCodeFind();

        // 尝试登陆
        window.tryLogin("", window.auth_code, "verifyCode");
    }
}

// 定时轮询授权码窗口是否出来
function pollAuthCodeWidow() {
    if (window.globle_tmid == 0) {
        window.globle_tmid = window.setInterval("doPollAuthCodeWidow()", 1000);
    }
}

function setEmailToEdit(param) {
    userEdit = document.getElementById('u');
    if (userEdit) {
        if (!!param.email) {
            userEdit.value = param.email;
            var uni_tips = document.getElementById('uin_tips');
            uni_tips.style.display = "none";
            document.getElementById('p').focus();
	    } else {
		    userEdit.focus();
        }
    }
}

;(function(){
window.globle_tmid = 0;
window.isResize = false;
window.oldWidth = screen.width;

window.onresize = function () {
    if (!window.isResize && window.oldWidth != screen.width) {
        window.isResize = true;
        location.reload();
        setTimeout(function(){
            window.isResize = false;
        }, 1000);
    }
}

// 添加提示条
window.addTopTips = function(content) {
   var param={};
   param.tips = content;
   window.appHost.invoke("showHeadTips", param);
};

window.addBottomBtn = function(btnText, onBtnClicked) {
    var param={};
    param.buttonText = btnText;
    window.appHost.invoke("showBottomBtn", param, onBtnClicked);
};

window.removeBottomBtn = function() {
    window.appHost.invoke("hideBottomBtn", {});
};

window.onHasSendMessageClicked = function() {
    var a = document.getElementById("security-dialog_QMDialog_proxyiframe");
    var b = a.contentDocument.getElementById("fm_proxyFrame");
    var verify_btn = b.contentDocument.getElementById("verify_btn");
    if (verify_btn) {
        verify_btn.click();
    }
};

 window.showHasSendMessage = function() {
     window.setTimeout(function() {
        window.addBottomBtn("我已发送短信", function() {
            onBottomBtnClick(5)();
            showHasSendMessage();
        });
     }, 500);
 }

 window.showSendMessageBtn = function() {
      window.setTimeout(function() {
         window.addBottomBtn("发送短信", function() {
             onBottomBtnClick(1)();
             showSendMessageBtn();
             // window.showHasSendMessage();
         });
      }, 500);
 }

window.onBottomBtnClick = function(type){
    return function() {
        switch(type) {
                case 1:
                    var param={};
                    param.telNumber="1069070069";
                    param.content="配置邮件客户端";
                    window.appHost.invoke("sendMessage",param);
                    break;
                case 2:
                    window.appHost.invoke("openUrl",{"url":"https://aq.qq.com"});
                    break;
                case 3:
                    tryToShowIMAPDialog()
                    break;
                case 4:
                    window.tryLogin("", "", "verifyCode");
                    break;
                case 5:
                    window.onHasSendMessageClicked();
                    break;
            }
    }
};

window.tryLogin = function(email, pwd, type) {
    window.appHost.invoke(
        "tryLogin",
         {
            "email": email,
            "pwd": pwd,
            "type": type
         }
    );
};

window.tryHideAdNode = function(){
	var adNode=document.querySelector("div.top_announce");
	if(!!adNode){
		adNode.style.display="none"
	}
};

window.accountAndPwdLogin = function(){
	var p=document.getElementById("p");
	var go=document.getElementById("login_button");
	var u=document.getElementById("u");
	if(!!p&&!!go&&!!u){
        // 切换到账密tab
        var switcher_plogin=document.getElementById("switcher_plogin");
        if(!!switcher_plogin){
            try{
                switcher_plogin.click();
            }catch(e){
            }
        }

		window.addTopTips("请先登录网页版QQ邮箱");
		go.onclick=function(event){
			window.tryLogin(u.value, p.value, "password");
		};
		p.onkeydown=function(event){
			if(event.keyCode===13){
				window.tryLogin(u.value, p.value, "password");
			}
		}
        var submit = document.getElementsByClassName("submit");
        if (submit.length > 0) {
            submit[0].style.backgroundColor = "#ffffff";
        }
	}
};

window.independentPasswordLogin = function(){
	var independentPasswordLabel=document.querySelector(".username_immutable");
	if(independentPasswordLabel){
		var independentLoginBtn=document.getElementById("btlogin");
		var independentPwd=document.getElementById("pp");
		if(!!independentLoginBtn&&!!independentPwd){
            independentLoginBtn.addEventListener('click',
                function(){
                    window.tryLogin("", independentPwd.value, "password");
                });

            independentPwd.addEventListener('onkeypress',
                function(event){
                    if(event.keyCode===13){
                        independentLoginBtn.click();
                        window.tryLogin("", independentPwd.value, "password");
                    }
                });

            window.addTopTips("请先登录网页版QQ邮箱");

		     // footer置底
            var footer=document.getElementsByClassName("footer");
            footer[0].style.position = "absolute";
            footer[0].style.transform = "translateY(0)";
            footer[0].style.bottom = "0";
		}
	}
};

window.autoScrollInMainFrame = function(){
	var mf=window.frames["mainFrame"];
	if(!!mf){
		var doc=mf.document;
		var sc=doc.getElementById("scrollContainer");
		var pop=doc.getElementById("pop3Info");
		if(!!sc){
			if(!!pop){
				sc.scrollTop=pop.offsetTop
			}else{
				sc.scrollTop=1000
			}
		}else{
			console.log("not found")
		}
	}
};

window.isProtocolNodeDisable = function(node){
	if(!!!node||!!!node.lastElementChild){
		return true
	}
	return"开启"==node.lastElementChild.innerText
};

window.tryToShowIMAPDialog = function(){
	var setting=document.getElementById("frame_html_setting");
	if(!!setting){
		var dialogFunc=window.document.getElementById("mainFrame").contentWindow.openSecurityDialog;
		var tipFunc=window.document.getElementById("mainFrame").contentWindow.openSecurityTips;
		if(!(!!dialogFunc||!!tipFunc)){
			window.location.href=setting.href;
			window.removeBottomBtn();
		}else{
			var imapNode=document.getElementById("mainFrame").contentDocument.getElementById("div_imap_smtp");
			var cardDavNode=document.getElementById("mainFrame").contentDocument.getElementById("div_carddav_caldav");
			var isDialog=true;
			if(!!imapNode&&(imapNode.lastElementChild.nodeName.toLowerCase()=="a")){
				var imapLast=imapNode.lastElementChild;
				if(imapLast.outerHTML.indexOf("openSecurityTips")>0){
					isDialog=false
				}
				if(!!isDialog){
                    if(!isProtocolNodeDisable(imapNode)&&isProtocolNodeDisable(cardDavNode)){
                        dialogFunc("carddav_caldav","opendav",1,"CardDav/CalDav");
                        console.log("open carddav_caldav")
                    }else{
                        dialogFunc('genauthcode' , '' , '3' , '');
                        console.log("open imap_smtp")
                    }
                    window.setTimeout(function() {
                        window.addTopTips("发送短信，获取第三方客户端授权码");
                        centerPopWindow('security-dialog_QMDialog');
                        addPrompt(false);
                        addPrompt2(false);
                        showSendMessageBtn();
                        window.setTimeout(pollAuthCodeWidow, 1000);
                    }, 2000);
				} else {
                    window.addBottomBtn("申请密保", onBottomBtnClick(2));
					window.document.getElementById("security-dialogOpen_QMDialog_confirm")
					    .onclick=onBottomBtnClick(2);
				}
			}else{
				window.removeBottomBtn();
				var tips=document.getElementById("mainFrame").contentDocument
				    .querySelector("p.infobar.infobar_tip");
				if(tips){
					window.addTopTips(tips.textContent);
				}
			}
		}
	}
};

window.getQueryString = function(name){
	var reg=new RegExp("(^|&)"+name+"=([^&]*)(&|$)","i");
	var r=window.location.search.substr(1).match(reg);
	if(r!=null){
		return unescape(r[2])
	}
	return null
};

window.getLatestAccountEmail = function(){
    try {
        var accountEmail=getQueryString("clientuin");
        if(accountEmail!=null){
            window.tryLogin(accountEmail, "", "email");
        }
    } catch (error) {
        console.error(error);
    }
};

window.autoJumpToNext = function(){
	if(window.location.href.indexOf("https://mail.qq.com/cgi-bin/readtemplate")==0){
		window.location.href="https://mail.qq.com/cgi-bin/login?vt=passport&vm=wpt&ft=loginpage&target="
	}
};

window.autoRefreshState = function(){
	var elements=document.getElementsByClassName("enter_mail_button_td");
	if(elements.length>0){
		var children=elements[0].children;
		if(children.length>0){
			var btn=children[0];
			if(!!btn){
				btn.click()
			}
		}
	}
};

try {
    getLatestAccountEmail();
    autoRefreshState();
} catch (error) {
     console.error(error);
}

try {
    accountAndPwdLogin();
    tryHideAdNode();
} catch (error) {
     console.error(error);
}

try {
    independentPasswordLogin();
} catch (error) {
     console.error(error);
}

try {
    autoScrollInMainFrame();
} catch (error) {
     console.error(error);
}

autoJumpToNext();
tryToShowIMAPDialog();
document.addEventListener("touchstart", tc, true);
document.addEventListener("touchmove", tc, true);
document.addEventListener("touchend", tc, true);
document.addEventListener("touchcancel", tc, true);
})();